unit UnidadMenuPrincipal;

{$R WinXP.res}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComObj, OleCtrls, AcroPDFLib_TLB, ComCtrls, Buttons, shellapi,
  jpeg, ExtCtrls;

type
  TformMenuPrincipal = class(TForm)
    dlAbrir: TOpenDialog;
    dlGuardar: TSaveDialog;
    PageControl1: TPageControl;
    tabExtraer: TTabSheet;
    Label1: TLabel;
    lInfoProgreso: TLabel;
    txtFichero: TEdit;
    bSelFichero: TButton;
    bExtraerTexto: TButton;
    txtTexto: TMemo;
    bp: TProgressBar;
    bGuardar: TButton;
    bSalir: TButton;
    bVisualizar: TButton;
    tabVisualizar: TTabSheet;
    pdfVisualizador: TAcroPDF;
    LWEB: TLabel;
    tabAcercaDe: TTabSheet;
    Shape1: TShape;
    Image1: TImage;
    txtInfo: TMemo;
    Label17: TLabel;
    lForos: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    lNombreAplicacion: TLabel;
    lVersion: TLabel;
    procedure bExtraerTextoClick(Sender: TObject);
    procedure tabVisualizarShow(Sender: TObject);
    procedure bCerrarClick(Sender: TObject);
    procedure bSelFicheroClick(Sender: TObject);
    procedure bGuardarClick(Sender: TObject);
    procedure habilitarControles (habilitar : boolean);

    //para arrastrar y soltar
    procedure SoltarFichero  (var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure FormCreate(Sender: TObject);
    procedure bVisualizarClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
    procedure Label22Click(Sender: TObject);
    procedure lForosClick(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

procedure TformMenuPrincipal.SoltarFichero (var Msg : TWMDropFiles);
var
  CFileName: array[0..MAX_PATH] of Char;
begin
  try
    if DragQueryFile(Msg.Drop, 0, CFileName, MAX_PATH) > 0 then
    begin
      txtFichero.Text := CFileName;
      Msg.Result := 0;
    end;
  finally
    DragFinish(Msg.Drop); //finaliza arrastrar y soltar
  end;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  //permitimos arrastrar y soltar
  DragAcceptFiles(Handle, True);

  lNombreAplicacion.Caption := Application.Title;
  lVersion.Caption := 'Versin 1.0.2.33 (29-05-2008)';

  tabExtraer.Show;  
end;

function obtenerTextoPaginaPDF(numPagina : integer; objPDF : Variant) : string;
var
  i : integer;
  paginaPDF, paginaHilitelist, paginaActual : Variant;
  resultadoEj : boolean;
  textoPDF : string;
begin
  textoPDF := '';
  Result := '';
  try
    //creamos un objeto de pgina pdf, desde una pgina especificada
    paginaPDF := objPDF.AcquirePage(numPagina);

    //crearemos un objeto "hilitelist", lo utilizaremos para extraer el texto
    paginaHilitelist := CreateOleObject('acroexch.hilitelist');

    resultadoEj := paginaHilitelist.Add(0, 9000);

    if resultadoEj then
    begin
      paginaActual := paginaPDF.CreatePageHilite(paginaHilitelist);

      for i := 0 to paginaActual.GetNumText - 1 do
      begin
        textoPDF := textoPDF + paginaActual.GetText(i);
      end;
      result := textoPDF;

      paginaPDF := Unassigned;
      paginaHilitelist := Unassigned;
    end;
  except
  end;
end;

procedure TformMenuPrincipal.habilitarControles (habilitar : boolean);
begin
  if habilitar then
    Cursor := crDefault
  else
    Cursor := crHourGlass;
  txtFichero.Enabled := habilitar;
  txtTexto.Enabled := habilitar;
  bGuardar.Enabled := habilitar;
  bSalir.Enabled := habilitar;
  bSelFichero.Enabled := habilitar;
  bExtraerTexto.Enabled := habilitar;
end;

procedure TformMenuPrincipal.bExtraerTextoClick(Sender: TObject);
var
  conexionPDF : Variant;
  numPaginas, i : integer;
  textoPDF : string;
begin
  if FileExists(txtFichero.Text) then
  begin
    habilitarControles(False);
    textoPDF := '';
    txtTexto.clear;

    try
      conexionPDF := CreateOleObject ('acroexch.pddoc');
      conexionPDF.Open (txtFichero.Text);
      numPaginas :=  conexionPDF.getNumPages;
      if numPaginas > 0 then
      begin
        bp.Min := 0;
        bp.Max := numPaginas - 1;
        for i := 0 to numPaginas - 1 do
        begin
          lInfoProgreso.Caption := 'Obteniendo pgina ' + IntToStr(i + 1) +
              ' de ' + IntToStr(numPaginas);
          lInfoProgreso.Refresh;
          bp.Position := i;
          textoPDF := textoPDF + obtenerTextoPaginaPDF(i, conexionPDF);
        end;
        txtTexto.Text := textoPDF;
        conexionPDF := Unassigned;
        habilitarControles(True);
      end
      else
        MessageDlg('No se ha podido leer la estructura del fichero PDF. ' +
            'Asegrese de que el formato es correcto.', mtInformation, [mbok], 0);
    except
      habilitarControles(True);
      raise;
    end;
  end
  else
  begin
    MessageDlg('No existe el fichero PDF seleccionado.', mtInformation, [mbok], 0);
    txtFichero.SetFocus;
  end;
end;

procedure TformMenuPrincipal.tabVisualizarShow(Sender: TObject);
begin
  if FileExists(txtFichero.Text) then
  begin
    pdfVisualizador.LoadFile(txtFichero.Text);
    pdfVisualizador.Visible := true;
  end
  else
    pdfVisualizador.Visible := false;
end;

procedure TformMenuPrincipal.bCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.bSelFicheroClick(Sender: TObject);
begin
  if dlAbrir.Execute then
    txtFichero.Text := dlAbrir.FileName;
end;

procedure TformMenuPrincipal.bGuardarClick(Sender: TObject);
begin
  dlGuardar.FileName := ChangeFileExt(ExtractFileName(txtFichero.Text), '.txt');
  if dlGuardar.Execute then
    txtTexto.Lines.SaveToFile(dlGuardar.FileName);
end;

procedure TformMenuPrincipal.bVisualizarClick(Sender: TObject);
begin
  tabVisualizar.Show;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.Label22Click(Sender: TObject);
begin
  ShellExecute(Handle, Nil,
      PChar('http://www.ajpdsoft.com/modules.php?name=News&file=article&sid=291'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.lForosClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil,
      PChar('http://www.ajpdsoft.com/modules.php?name=Foros&file=viewforum&f=9'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
